feat(wpcarro): Define deploy-diogenes helper

TL;DR:
- Mimmick depot's bin -> __dispatch.sh for personal utils
- Define deploy-diogenes to more tighten my feedback loop

Change-Id: I2b12a1c32a955574f5be5d4f38025bd97e9c7b77
Reviewed-on: https://cl.tvl.fyi/c/depot/+/4751
Tested-by: BuildkiteCI
Reviewed-by: wpcarro <wpcarro@gmail.com>
Autosubmit: wpcarro <wpcarro@gmail.com>
This commit is contained in:
William Carroll 2021-12-30 15:25:03 -04:00 committed by clbot
parent d24eef0735
commit 6500fb551f
4 changed files with 42 additions and 2 deletions

View file

@ -1,2 +1,3 @@
source_up
export WPCARRO="$REPO_ROOT/users/wpcarro"
export PATH="${PWD}/bin:${PATH}"
export WPCARRO="${REPO_ROOT}/users/wpcarro"

24
users/wpcarro/bin/__dispatch.sh Executable file
View file

@ -0,0 +1,24 @@
#!/usr/bin/env bash
# This script dispatches invocations transparently to programs instantiated from
# Nix.
#
# To add a new tool, insert it into the case statement below by setting `attr`
# to the key in nixpkgs which represents the program you want to run.
set -ueo pipefail
TARGET_TOOL=$(basename "$0")
case "${TARGET_TOOL}" in
deploy-diogenes)
attr="users.wpcarro.nixos.deploy-diogenes"
;;
*)
echo "The tool '${TARGET_TOOL}' is currently not installed in this repository."
exit 1
;;
esac
result=$(nix-build --no-out-link --attr "${attr}" "${REPO_ROOT}")
PATH="${result}/bin:$PATH"
exec "${TARGET_TOOL}" "${@}"

View file

@ -0,0 +1 @@
__dispatch.sh

View file

@ -1,8 +1,22 @@
{ depot, ... }:
{ depot, pkgs, ... }:
let systemFor = sys: (depot.ops.nixos.nixosFor sys).system;
in {
marcusSystem = systemFor depot.users.wpcarro.nixos.marcus;
deploy-diogenes = pkgs.writeShellScriptBin "deploy-diogenes" ''
set -euo pipefail
readonly TF_STATE_DIR=/depot/users/wpcarro/terraform
rm -f $TF_STATE_DIR/*.json
readonly STORE_PATH="$(nix-build /depot -A users.wpcarro.nixos.diogenes)"
cp $STORE_PATH $TF_STATE_DIR
function cleanup() {
rm -f "$TF_STATE_DIR/$(basename $STORE_PATH)"
}
trap cleanup EXIT
${pkgs.terraform}/bin/terraform -chdir="$TF_STATE_DIR" apply
'';
meta.targets = [ "marcusSystem" ];
}